# coding: utf-8

"""
    HiddenLayer-API

    HiddenLayer-API

    The version of the OpenAPI document: 1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class ScanModelDetailsV3(BaseModel):
    """
    ScanModelDetailsV3
    """ # noqa: E501
    model_name: StrictStr = Field(description="name of the model")
    model_version: StrictStr = Field(description="version of the model")
    model_source: Optional[StrictStr] = Field(default=None, description="source (provider) info")
    requested_scan_location: StrictStr = Field(description="Location to be scanned")
    requesting_entity: Optional[StrictStr] = Field(default=None, description="Entity that requested the scan")
    request_source: Optional[StrictStr] = Field(default=None, description="Source of the request")
    origin: Optional[StrictStr] = Field(default=None, description="Origin of the scan")
    __properties: ClassVar[List[str]] = ["model_name", "model_version", "model_source", "requested_scan_location", "requesting_entity", "request_source", "origin"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ScanModelDetailsV3 from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ScanModelDetailsV3 from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "model_name": obj.get("model_name"),
            "model_version": obj.get("model_version"),
            "model_source": obj.get("model_source"),
            "requested_scan_location": obj.get("requested_scan_location"),
            "requesting_entity": obj.get("requesting_entity"),
            "request_source": obj.get("request_source"),
            "origin": obj.get("origin")
        })
        return _obj


